#!/bin/bash

function curlx() {
  curl -Ssk -u admin:admin "https://ear-opensearch-node1:9200/${1}" -H 'content-type: application/json' "${@:2}"
}

function curlxpost() {
  curl -XPOST -Ssk -u admin:admin "https://ear-opensearch-node1:9200/${1}" -H 'content-type: application/json' "${@:2}"
}


curlx "_snapshot/my_fs_backup?pretty" -d '

{
  "type": "fs",
  "settings": {
    "location": "/snapshots/my_fs_backup"
  }
}

'
echo
curlx "_snapshot/my_encrypted_fs_backup?pretty" -d '

{
  "type": "encrypted",
  "settings": {
    "delegate": "my_fs_backup"
  }
}

'
echo
curlx "_index_template/encrypted_index_template?pretty" -d '
{
  "index_patterns": ["*encrypted*","*dashboards_sample*"],
  "priority": 300,
  "template": {
    "mappings": {
      "properties": {
        "_encrypted_tl_content": {
          "type": "binary"
        }
      }
    },
    "settings":{
      "encryption_enabled": true,
      "number_of_shards": 3,
      "number_of_replicas": 2,
      "store.type": "encrypted"
    }
  }
}'
echo



for i in `seq 1 10`;
do

curlx "other/_doc?refresh=true&pretty" -d '
{
    "full_name":"Captain other",
    "credit_card_number":"5162",
    "age":39,
    "remarks":"any others"
}
'
echo
done

for i in `seq 1 10`;
do

curlx "encrypted/_doc?refresh=true&pretty" -d '
{
    "full_name":"Captain Kirk _clt_ fiar",
    "credit_card_number":"1234_clt_fiar",
    "age":45,
    "remarks":"take care fiar"
}
'
echo
done

curlxpost "_refresh"
echo
curlxpost "_flush"
echo
curlx "_snapshot/my_encrypted_fs_backup/snapshot_1?wait_for_completion=true&pretty" -d'
{
  "indices": "*encrypted*,*other*",
  "ignore_unavailable": true,
  "include_global_state": true
}
'
echo
curlx "_snapshot/my_encrypted_fs_backup/snapshot_1/_restore?wait_for_completion=true"  -d'
{
  "indices": "*encrypted*,*other*",
  "include_global_state": false,
  "rename_pattern": "(.+)",
  "rename_replacement": "restoredindex_$1"
}
'
echo